public class TestRelation{
    private static final int taille = 11;
    
    private static void resultatTest( boolean condition,String nomFonction){
	if (condition)
	    System.out.println("Test " + nomFonction + " passe avec succes");
	else
	    {
		System.out.println("Erreur test "+ nomFonction);
		System.exit(1);
	    }
    }

    public static void main(String[] arg){

	boolean[][] estMultipleDe = new boolean[taille][taille];
	estMultipleDe[0][0]=true;
	for (int i=1; i < taille ; i++)
	    {
		estMultipleDe[i][0] = false;
		for (int j =1; j < taille ; j++)
		    estMultipleDe[i][j] = ( i % j == 0);
	    }
	
	boolean[][] estCongruAmodulo2 = new boolean[taille][taille];
	for (int i=0; i < taille ; i++)
	    for (int j =0; j < taille ; j++)
		estCongruAmodulo2[i][j] = ( (i-j) % 2 == 0);
 
	boolean[][] estStrictementInferieur = new boolean[taille][taille];
	for (int i=0; i < taille ; i++)
	    for (int j =0; j < taille ; j++)
		estStrictementInferieur[i][j] = (i<j);
 
	boolean[][] plus2Moins3 = new boolean[taille][taille];
	for (int i=0; i < taille ; i++)
	    for (int j =0; j < taille ; j++)
		if ( j == i + 2 || j == i - 3 )
		    plus2Moins3[i][j] = true;


	resultatTest (Relation.reflexive(estMultipleDe) &&
	    Relation.reflexive(estCongruAmodulo2)&& 
	    !Relation.reflexive(estStrictementInferieur) &&
		      !Relation.reflexive(plus2Moins3) , "reflexive");

// 	resultatTest(!Relation.symetrique(estMultipleDe) &&
// 	    Relation.symetrique(estCongruAmodulo2)&& 
// 	    !Relation.symetrique(estStrictementInferieur) &&
// 		     !Relation.symetrique(plus2Moins3),"symetrique" );

// 	resultatTest(Relation.transitive(estMultipleDe) &&
// 	    Relation.transitive(estCongruAmodulo2)&& 
// 	    Relation.transitive(estStrictementInferieur) &&
// 		     !Relation.transitive(plus2Moins3), "transitive" );
	
// 	boolean[][] composee= Relation.composee(plus2Moins3,plus2Moins3);
// 	boolean comp=true;

// 	for(int i=0; i< composee.length; i++)
// 	    for(int j=0; j< composee.length; j++)
// 		if (j == i + 4 || j == i - 1 || j == i - 6)
// 		  {
// 		      if (!composee[i][j])
// 			  comp = false;
// 		  }
// 		else
// 		    if (composee[i][j])
// 			comp = false;
// 	resultatTest(comp,"composee");


// 	int[] image = Relation.image(composee,6);
// 	resultatTest (image.length == 3 && image[0] == 0 &&
// 		      image[1] == 5 && image[2] == 10 ,"image");
		
    }
}
